
(setq sk-qwerty `((?` 1 2 3 4 5 6 7 8 9 0 - = (BKSP . backward-delete-char-untabify))
                  (TAB q w e r t y u i o p [ ] \\)
                  (CAPS a s d f g h j k l \; ' RETURN)
                  (SHIFT z x c v b n m , . / INS DEL)
                  (CTRL ALT SPACE LEFT RIGHT UP DOWN PU PD HOME END ESC)))

(defun sk-clicked (event)
  (interactive "e")
  (let* ((posn (event-start event))
         (c (save-excursion
              (set-buffer (window-buffer (posn-window posn)))
              (char-after (posn-point posn)))))
    ;(insert c)
    (setq unread-command-events (list (cons t c)))
    ))

(defun sk-noop ()
  (interactive)
  'nothing)

; (setq sk-keymap nil)
(setq sk-keymap (let ((m (make-sparse-keymap)))
                  (define-key m [down-mouse-1] 'sk-clicked)
                  (define-key m [mouse-1] 'sk-noop)
                  (define-key m [double-mouse-1] 'sk-noop)
                  (define-key m [drag-mouse-1] 'sk-noop)
                  (define-key m [triple-mouse-1] 'sk-noop)
                  (define-key m [left-fringe mouse-1] 'sk-noop)
                  (define-key m [right-fringe mouse-1] 'sk-noop)
                  m))

(defun showsk ()
  "Pop up a soft keyboard."
  (interactive)
  (save-excursion
    (set-buffer (get-buffer-create "*Keyboard*"))
    (setq buffer-read-only nil)
    (setq mode-line-format nil)
    (erase-buffer)
    (insert "\
q w e r t y u i o p
 a s d f g h j k l
  z x c v b n m")
    (setq buffer-read-only t)
    (goto-char (point-min))
    (use-local-map sk-keymap)
    (set-window-text-height (display-buffer (current-buffer) t) 3)))